import alsaaudio as aa
import random
import sys
import wave
from struct import unpack
import numpy as np
import time
from rpi_ws281x import *
import RPi.GPIO as GPIO
import time
import os, sys

calcError = False

# LED strip configuration:
LED_COUNT      = 50      # Number of LED pixels.
LED_PIN        = 18      # GPIO pin connected to the pixels (18 uses PWM!).
#LED_PIN        = 10      # GPIO pin connected to the pixels (10 uses SPI /dev/>
LED_FREQ_HZ    = 800000  # LED signal frequency in hertz (usually 800khz)
LED_DMA        = 10      # DMA channel to use for generating signal (try 10)
LED_BRIGHTNESS = 128      # Set to 0 for darkest and 255 for brightest
LED_INVERT     = False   # True to invert the signal (when using NPN transistor>
LED_CHANNEL    = 0       # set to '1' for GPIOs 13, 19, 41, 45 or 53


def clear(strip):
    for i in range(LED_COUNT):
        strip.setPixelColor(i, 0)
    strip.show()


def cycleDown(strip):
    clear(strip)

    while True:
        for j in range(256):
            for i in range(0, 26):
                strip.setPixelColor(24 + i, wheel((int((48 + i) * 256 / 48) + j) & 255))
                strip.setPixelColor(25 - i, wheel((int((48 + i) * 256 / 48) + j) & 255))
            strip.show()
            time.sleep(10/100.0)
            if GPIO.input(4):
                return

def shred(output,songname, strip):
    global calcError
#    print("Playing song: ", songname)
    chunk = 4096
    wavefile = wave.open(songname)
    sample_rate = wavefile.getframerate()
    num_channels = wavefile.getnchannels()
    num_frames = wavefile.getnframes()
    num_chunks = num_frames / chunk
    sample_width = wavefile.getsampwidth()
    frame_rate = wavefile.getframerate()

    data = wavefile.readframes(chunk)

    clear(strip)

    while (data != '') and (calcError == False):
        output.write(data)
        matrix = calculate_levels(data,chunk)

        if calcError == True:
            clear(strip)
        else:
            lights(strip,  matrix)

        data = wavefile.readframes(chunk)

    wavefile.close()

def calculate_levels(data, chunk):
    global calcError
    try:
        data = unpack("%dh"%(len(data)/2),data)
        data = np.array(data,dtype='h')
        fourier = np.fft.rfft(data)
        fourier = np.delete(fourier,len(fourier)-1)
        power = np.log10(np.abs(fourier))**2
        power = np.reshape(power,(64,64))
        matrix = np.int_(np.average(power,axis=1))
        return matrix
    except:
#        print("Calculate error")
        calcError = True

def lights(strip, matrix):
    clear(strip)

    try:
        amp1 = matrix[24]
        amp2 = matrix[40]
        amp3 = matrix[48]
        amp4 = matrix[32] 
    except:
        return

    # right guitar body
    amp1 = int((amp1-4)/1.5)

    if amp1 < 0:
        ampl1 = 0

    if amp1 > 9:
        amp1 = 9

    for i in range(0, amp1):
        strip.setPixelColor(i, wheel(i * 5))

    # right guitar neck
    amp2 = int((amp2 - 3)/1.2)

    if amp2 < 0:
        amp2 = 0

    if amp2 > 12:
        amp2 = 12

    for i in range(10, amp2 + 10):
        strip.setPixelColor(i, wheel((i - 10) * 10) + 180)

    # left guitar neck
    amp3 = int((amp3 - 16) * 1.3)

    if amp3 < 0:
        amp3 = 0

    if amp3 > 12:
        amp3 = 12

    for i in range(33, amp3 + 21, -1):
        strip.setPixelColor(i, wheel(300 - ((i - 19) * 9)))

    # left guitar body
    amp4 = int(amp4 - 8)

    if amp4 < 0:
        amp4 = 0

    if amp4 > 15:
        amp4 = 15

    for i in range(49, amp4 + 34, -1):
        strip.setPixelColor(i, wheel(180 - ((i-31) * 10)))

    strip.show()

def wheel(pos):
    if pos  > 255:
        pos = 255

    if pos < 0:
        pos = 0

    if pos < 85:
        return Color(pos * 3, 255 - pos * 3, 0)
    elif pos < 170:
        pos -= 85
        return Color(255 - pos * 3, 0, pos * 3)
    else:
        pos -= 170
        return Color(0, pos * 3, 255 - pos * 3)

def main():
    global calcError

    strip = Adafruit_NeoPixel(LED_COUNT, LED_PIN, LED_FREQ_HZ, LED_DMA, LED_INVERT, LED_BRIGHTNESS, LED_CHANNEL)
    strip.begin()
    clear(strip)

    output = aa.PCM(aa.PCM_PLAYBACK,aa.PCM_NORMAL,rate=44100,channels=2,card="UACDemoV10")
    output.setformat(aa.PCM_FORMAT_S16_LE)
    os.system("amixer -c UACDemoV10 set PCM 70%")

    GPIO.setmode(GPIO.BCM)
    GPIO.setup(4, GPIO.IN)

    song = random.randint(1, 15)

#    time.sleep(2)

    while True:
        cycleDown(strip)

        songname = "/home/pi/Music/Shred" + str(song).zfill(2) + ".wav"
        shred(output, songname, strip)
        calcError = False

        song = song + 1

        if song > 15:
            song = 1

        time.sleep(2)

if __name__ == '__main__':
    main()
